export declare type ArrayVector3 = [number, number, number];
export declare function isArrayVector3(arrayVector: any): arrayVector is ArrayVector3;
export declare type ArrayVector4 = [number, number, number, number];
export declare function isArrayVector4(arrayVector: any): arrayVector is ArrayVector4;
export declare type TextureRotationAngle = 0 | 90 | 180 | 270;
export interface MinecraftModelFace {
    texture: string;
    uv?: ArrayVector4;
    rotation?: TextureRotationAngle;
}
export declare function isMinecraftModelFace(face: any): face is MinecraftModelFace;
export declare type MinecraftModelFaceName = 'west' | 'east' | 'down' | 'up' | 'north' | 'south';
export declare type ElementRotationAngle = -45 | -22.5 | 0 | 22.5 | 45;
export declare type ElementRotationAxis = 'x' | 'y' | 'z';
export interface MinecraftModelElementRotation {
    origin: ArrayVector3;
    angle: ElementRotationAngle;
    axis: ElementRotationAxis;
    rescale?: boolean;
}
export declare function isMinecraftModelElementRotation(rotation: any): rotation is MinecraftModelElementRotation;
export interface MinecraftModelElement {
    from: ArrayVector3;
    to: ArrayVector3;
    rotation?: MinecraftModelElementRotation;
    faces: {
        [name in MinecraftModelFaceName]: MinecraftModelFace;
    };
}
export declare function isMinecraftModelElement(element: any): element is MinecraftModelElement;
export interface MinecraftModel {
    textures: {
        [name: string]: string;
    };
    elements: MinecraftModelElement[];
}
export declare function isMinecraftModel(model: any): model is MinecraftModel;
//# sourceMappingURL=model.d.ts.map